using Ravengar
module Ravengar
  refine Object do
    def show(output = $stdout, separator: "\n")
      ->(it) { output << it.inspect << separator; it }
    end
    def filter(lambd)
      ->(it) do
        value = lambd.call(it)
        if value
          it
        else
          skip!
        end
      end
    end
    def replicator(*lambds)
      ->(it) do
        lambds.map { |lambd| lambd.call(it) }
      end
    end
    def diffuser(*lambds)
      diffus = lambds.cycle
      ->(*args) do
        diffus.next.call(*args)
      end
    end
  end
end
