require 'ravengar/proc'
using Ravengar
module Ravengar
  class SourceWrapper
    include Enumerable
    def initialize(source)
      @source = source
      @head_lambda = ->(it) { it }
    end

    def |(lambd)
      @head_lambda = @head_lambda | lambd
      self
    end

    def call
      run
    end

    def each
      catch :abort_proc do
        @source.each do |it|
          catch :skip_proc do
            yield @head_lambda.call(it)
          end
        end
      end
    ensure
      @source.close if @source.respond_to?(:close)
    end

    def ~@
      self.each { |it| it }
      @source
    end

    def !@
      self.map { |it| it }
    end
  end

  refine Object do
    def skip!
      throw :skip_proc
    end
    def abort!
      throw :abort_proc
    end
  end
end
